//+------------------------------------------------------------------+
//|                                          Get_ASCTrend1Series.mqh |
//|                        Copyright  2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru |
//+------------------------------------------------------------------+
bool Get_ASCTrend1Series(int Number, string symbol,int timeframe, 
                         bool NullBarRecount, int RISK, 
                         double& InputBuffer[])
  {
//----     
   int IBARS = iBars(symbol, timeframe);  
//----        
   if((IBARS < 3 + RISK*2 + 1) || (IBARS < 10))
       return(false);
//----   
   if(ArraySize(InputBuffer) < IBARS)
     {
       ArraySetAsSeries(InputBuffer, false);
       //----  
       ArrayResize(InputBuffer, IBARS); 
       //----
       ArraySetAsSeries(InputBuffer, true);
     } 
//----+     
   static double x1[], x2[];
   static int IndCounted[]; 
//----+    
   if(ArraySize(IndCounted)<Number+1)
     {
       ArrayResize(x1, Number + 1); 
       ArrayResize(x2, Number + 1); 
       ArrayResize(IndCounted, Number + 1); 
     }
//----+   
   int LastCountBar;
//----+     
   if(!NullBarRecount)
       LastCountBar = 1;
//----+      
   double value1, value2, value3, val1, val2;
   double TrueCount, Range, AvgRange, MRO1, MRO2;
//----+         
   int MaxBar, iii, kkk, bar, value10, value11, 
       counted_bars = IndCounted[Number];
//----+     
   IndCounted[Number] = IBARS - 1;
//----  
   value10 = 3 + RISK*2;
//----     , 
                  //       
   bar = IBARS - counted_bars - 1; 
//----     , 
//            
   MaxBar = IBARS - 1 - value10;
//----   
   if(bar > MaxBar)
     {
       bar = MaxBar;
       x1[Number] = 67 + RISK;
       x2[Number] = 33 - RISK;
       //----
       ArrayInitialize(InputBuffer, 0.0); 
     } 
//----   ר 
   while(bar >= LastCountBar)
     {  
       Range = 0.0;
       AvgRange = 0.0;
       for(iii = 0; iii <= 9; iii++) 
           AvgRange += MathAbs(iHigh(symbol, timeframe, bar + iii) -
                               iLow(symbol, timeframe, bar + iii));
	      //----
       Range = AvgRange / 10;
       iii = 0;
       TrueCount = 0;
       while(iii < 9 && TrueCount < 1)
	        {
	          if(MathAbs(iOpen(symbol, timeframe, bar + iii) -
	                     iClose(symbol, timeframe, bar + iii)) >= 
	                     Range*2.0) 
	              TrueCount++;
	          //----
	          iii++;
	        }
       if(TrueCount >= 1)
           MRO1 = bar + iii; 
       else 
           MRO1 = -1;
       //----
       iii = 0;
       TrueCount = 0;
       while(iii < 6 && TrueCount < 1)
	        {
	          if(MathAbs(iClose(symbol, timeframe, bar + iii + 3) -
	                     iClose(symbol, timeframe, bar + iii)) >= 
	                     Range*4.6) 
	              TrueCount++;
	          //----
	          iii++;
         }
       if(TrueCount >= 1)
           MRO2 = bar + iii; 
       else 
           MRO2 = -1;
       //----
       if(MRO1 > -1)
           value11 = 3; 
       else 
           value11 = value10;
       if(MRO2 > -1)
           value11 = 4; 
       else 
           value11 = value10;
       //----
       value2 = 100 - MathAbs(iWPR(symbol, timeframe, value11, bar));
       //---- 
       val1 = 0;
       val2 = 0;
       InputBuffer[bar] = 0;
       //---- 
       if(value2 > x1[Number])
         {
	          val1 = iLow (symbol, timeframe, bar);
	          val2 = iHigh(symbol, timeframe, bar);
         }
       if(value2 < x2[Number])
	        {
	          val1 = iHigh(symbol, timeframe, bar);
	          val2 = iLow (symbol, timeframe, bar);
	        } 
	      InputBuffer[bar] = val2 - val1;
       bar--;
     }
   //----+  
   return(true);
  }
//+------------------------------------------------------------------+